diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-remote-station-manager.h ns-3.43/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.42/src/wifi/model/wifi-remote-station-manager.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-remote-station-manager.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006,2007 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -70,9 +59,9 @@
 {
     virtual ~WifiRemoteStation(){};
     WifiRemoteStationState* m_state; //!< Remote station state
-    std::pair<double, Time>
-        m_rssiAndUpdateTimePair; //!< RSSI (in dBm) of the most recent packet received from the
-                                 //!< remote station along with update time
+    std::pair<dBm_u, Time>
+        m_rssiAndUpdateTimePair; //!< RSSI of the most recent packet received from
+                                 //!< the remote station along with update time
 };
 
 /**
@@ -120,15 +109,14 @@
     std::shared_ptr<CommonInfoBasicMle> m_mleCommonInfo;
     bool m_emlsrEnabled; //!< whether EMLSR mode is enabled on this link
 
-    uint16_t m_channelWidth;  //!< Channel width (in MHz) supported by the remote station
-    uint16_t m_guardInterval; //!< HE Guard interval duration (in nanoseconds) supported by the
-                              //!< remote station
-    uint8_t m_ness;           //!< Number of extended spatial streams of the remote station
-    bool m_aggregation;       //!< Flag if MPDU aggregation is used by the remote station
-    bool m_shortPreamble;     //!< Flag if short PHY preamble is supported by the remote station
-    bool m_shortSlotTime;     //!< Flag if short ERP slot time is supported by the remote station
-    bool m_qosSupported;      //!< Flag if QoS is supported by the station
-    bool m_isInPsMode;        //!< Flag if the STA is currently in PS mode
+    MHz_u m_channelWidth; //!< Channel width supported by the remote station
+    Time m_guardInterval; //!< HE Guard interval durationsupported by the remote station
+    uint8_t m_ness;       //!< Number of extended spatial streams of the remote station
+    bool m_aggregation;   //!< Flag if MPDU aggregation is used by the remote station
+    bool m_shortPreamble; //!< Flag if short PHY preamble is supported by the remote station
+    bool m_shortSlotTime; //!< Flag if short ERP slot time is supported by the remote station
+    bool m_qosSupported;  //!< Flag if QoS is supported by the station
+    bool m_isInPsMode;    //!< Flag if the STA is currently in PS mode
 };
 
 /**
@@ -376,11 +364,11 @@
      */
     bool GetShortGuardIntervalSupported() const;
     /**
-     * Return the supported HE guard interval duration (in nanoseconds).
+     * Return the supported HE guard interval duration.
      *
-     * \return the supported HE guard interval duration (in nanoseconds)
+     * \return the supported HE guard interval duration
      */
-    uint16_t GetGuardInterval() const;
+    Time GetGuardInterval() const;
     /**
      * Enable or disable protection for non-ERP stations.
      *
@@ -572,7 +560,7 @@
      *
      * \return the channel width supported by the station
      */
-    uint16_t GetChannelWidthSupported(Mac48Address address) const;
+    MHz_u GetChannelWidthSupported(Mac48Address address) const;
     /**
      * Return whether the station supports HT/VHT short guard interval.
      *
@@ -833,18 +821,18 @@
 
     /**
      * \param header MAC header
-     * \param allowedWidth the allowed width in MHz to send this packet
+     * \param allowedWidth the allowed width to send this packet
      * \return the TXVECTOR to use to send this packet
      */
-    WifiTxVector GetDataTxVector(const WifiMacHeader& header, uint16_t allowedWidth);
+    WifiTxVector GetDataTxVector(const WifiMacHeader& header, MHz_u allowedWidth);
     /**
      * \param address remote address
-     * \param allowedWidth the allowed width in MHz for the data frame being protected
+     * \param allowedWidth the allowed width for the data frame being protected
      *
      * \return the TXVECTOR to use to send the RTS prior to the
      *         transmission of the data packet itself.
      */
-    WifiTxVector GetRtsTxVector(Mac48Address address, uint16_t allowedWidth);
+    WifiTxVector GetRtsTxVector(Mac48Address address, MHz_u allowedWidth);
     /**
      * Return a TXVECTOR for the CTS frame given the destination and the mode of the RTS
      * used by the sender.
@@ -1044,14 +1032,14 @@
     /**
      * \param address of the remote station
      *
-     * \return the RSSI (in dBm) of the most recent packet received from the remote station
-     * (irrespective of TID)
+     * \return the RSSI of the most recent packet received from the remote station (irrespective of
+     * TID)
      *
      * This method is typically used when the device needs
      * to estimate the target UL RSSI info to put in the
      * Trigger frame to send to the remote station.
      */
-    std::optional<double> GetMostRecentRssi(Mac48Address address) const;
+    std::optional<dBm_u> GetMostRecentRssi(Mac48Address address) const;
     /**
      * Set the default transmission power level
      *
@@ -1232,9 +1220,9 @@
      *
      * \param station the station being queried
      *
-     * \return the channel width (in MHz) supported by the station
+     * \return the channel width supported by the station
      */
-    uint16_t GetChannelWidth(const WifiRemoteStation* station) const;
+    MHz_u GetChannelWidth(const WifiRemoteStation* station) const;
     /**
      * Return whether the given station supports HT/VHT short guard interval.
      *
@@ -1249,9 +1237,9 @@
      *
      * \param station the station being queried
      *
-     * \return the HE guard interval duration (in nanoseconds) supported by the station
+     * \return the HE guard interval duration supported by the station
      */
-    uint16_t GetGuardInterval(const WifiRemoteStation* station) const;
+    Time GetGuardInterval(const WifiRemoteStation* station) const;
     /**
      * Return whether the given station supports A-MPDU.
      *
@@ -1337,13 +1325,13 @@
     virtual WifiRemoteStation* DoCreateStation() const = 0;
     /**
      * \param station the station that we need to communicate
-     * \param allowedWidth the allowed width in MHz to send a packet to the station
+     * \param allowedWidth the allowed width to send a packet to the station
      * \return the TXVECTOR to use to send a packet to the station
      *
      * Note: This method is called before sending a unicast packet or a fragment
      *       of a unicast packet to decide which transmission mode to use.
      */
-    virtual WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, uint16_t allowedWidth) = 0;
+    virtual WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, MHz_u allowedWidth) = 0;
     /**
      * \param station the station that we need to communicate
      *
@@ -1389,14 +1377,14 @@
      * \param ackSnr the SNR of the ACK we received
      * \param ackMode the WifiMode the receiver used to send the ACK
      * \param dataSnr the SNR of the DATA we sent
-     * \param dataChannelWidth the channel width (in MHz) of the DATA we sent
+     * \param dataChannelWidth the channel width of the DATA we sent
      * \param dataNss the number of spatial streams used to send the DATA
      */
     virtual void DoReportDataOk(WifiRemoteStation* station,
                                 double ackSnr,
                                 WifiMode ackMode,
                                 double dataSnr,
-                                uint16_t dataChannelWidth,
+                                MHz_u dataChannelWidth,
                                 uint8_t dataNss) = 0;
     /**
      * This method is a pure virtual method that must be implemented by the sub-class.
@@ -1433,7 +1421,7 @@
      * \param nFailedMpdus number of unsuccessfuly transmitted MPDUs.
      * \param rxSnr received SNR of the block ack frame itself
      * \param dataSnr data SNR reported by remote station
-     * \param dataChannelWidth the channel width (in MHz) of the A-MPDU we sent
+     * \param dataChannelWidth the channel width of the A-MPDU we sent
      * \param dataNss the number of spatial streams used to send the A-MPDU
      */
     virtual void DoReportAmpduTxStatus(WifiRemoteStation* station,
@@ -1441,7 +1429,7 @@
                                        uint16_t nFailedMpdus,
                                        double rxSnr,
                                        double dataSnr,
-                                       uint16_t dataChannelWidth,
+                                       MHz_u dataChannelWidth,
                                        uint8_t dataNss);
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-phy-interface.cc ns-3.43/src/wifi/model/wifi-spectrum-phy-interface.cc
--- ns-3.42/src/wifi/model/wifi-spectrum-phy-interface.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-phy-interface.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
@@ -25,6 +14,8 @@
 #include "ns3/spectrum-channel.h"
 #include "ns3/spectrum-value.h"
 
+#include <sstream>
+
 NS_LOG_COMPONENT_DEFINE("WifiSpectrumPhyInterface");
 
 namespace ns3
@@ -42,7 +33,7 @@
 
 WifiSpectrumPhyInterface::WifiSpectrumPhyInterface(FrequencyRange freqRange)
     : m_frequencyRange{freqRange},
-      m_centerFrequency{0},
+      m_centerFrequencies{},
       m_channelWidth{0},
       m_bands{},
       m_heRuBands{}
@@ -107,15 +98,20 @@
 }
 
 void
-WifiSpectrumPhyInterface::SetRxSpectrumModel(uint32_t centerFrequency,
-                                             uint16_t channelWidth,
-                                             uint32_t bandBandwidth,
-                                             uint16_t guardBandwidth)
-{
-    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << bandBandwidth << guardBandwidth);
-    m_centerFrequency = centerFrequency;
+WifiSpectrumPhyInterface::SetRxSpectrumModel(const std::vector<MHz_u>& centerFrequencies,
+                                             MHz_u channelWidth,
+                                             Hz_u bandBandwidth,
+                                             MHz_u guardBandwidth)
+{
+    std::stringstream ss;
+    for (const auto& centerFrequency : centerFrequencies)
+    {
+        ss << centerFrequency << " ";
+    }
+    NS_LOG_FUNCTION(this << ss.str() << channelWidth << bandBandwidth << guardBandwidth);
+    m_centerFrequencies = centerFrequencies;
     m_channelWidth = channelWidth;
-    m_rxSpectrumModel = WifiSpectrumValueHelper::GetSpectrumModel(centerFrequency,
+    m_rxSpectrumModel = WifiSpectrumValueHelper::GetSpectrumModel(centerFrequencies,
                                                                   channelWidth,
                                                                   bandBandwidth,
                                                                   guardBandwidth);
@@ -145,13 +141,13 @@
     return m_frequencyRange;
 }
 
-uint16_t
-WifiSpectrumPhyInterface::GetCenterFrequency() const
+const std::vector<MHz_u>&
+WifiSpectrumPhyInterface::GetCenterFrequencies() const
 {
-    return m_centerFrequency;
+    return m_centerFrequencies;
 }
 
-uint16_t
+MHz_u
 WifiSpectrumPhyInterface::GetChannelWidth() const
 {
     return m_channelWidth;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-phy-interface.h ns-3.43/src/wifi/model/wifi-spectrum-phy-interface.h
--- ns-3.42/src/wifi/model/wifi-spectrum-phy-interface.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-phy-interface.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Nicola Baldo <nbaldo@cttc.es>
  */
@@ -25,6 +14,8 @@
 #include "ns3/he-phy.h"
 #include "ns3/spectrum-phy.h"
 
+#include <vector>
+
 namespace ns3
 {
 
@@ -91,20 +82,21 @@
     const FrequencyRange& GetFrequencyRange() const;
 
     /**
-     * Get the center frequency in MHz of the the spectrum channel this interface is attached to
+     * Get the center frequency for each segment of the the spectrum channel this interface is
+     * attached to
      *
-     * \return the center frequency in MHz of the the spectrum channel this interface is attached to
-     * to
+     * \return the center frequency for each segment of the the spectrum channel this interface is
+     * attached to to
      */
-    uint16_t GetCenterFrequency() const;
+    const std::vector<MHz_u>& GetCenterFrequencies() const;
 
     /**
-     * Get the channel width in MHz covered by the spectrum channel this interface is attached to
+     * Get the channel width covered by the spectrum channel this interface is attached to
      *
-     * \return the channel width in MHz covered by the spectrum channel this interface is attached
+     * \return the channel width covered by the spectrum channel this interface is attached
      * to to
      */
-    uint16_t GetChannelWidth() const;
+    MHz_u GetChannelWidth() const;
 
     /**
      * Start transmission over the spectrum channel
@@ -116,15 +108,15 @@
     /**
      * Set the RX spectrum model
      *
-     * \param centerFrequency the center frequency in MHz
-     * \param channelWidth the channel width in MHz
-     * \param bandBandwidth the width of each band in Hz
-     * \param guardBandwidth the width of the guard band in MHz
-     */
-    void SetRxSpectrumModel(uint32_t centerFrequency,
-                            uint16_t channelWidth,
-                            uint32_t bandBandwidth,
-                            uint16_t guardBandwidth);
+     * \param centerFrequencies the center frequency for each segment
+     * \param channelWidth the total channel width
+     * \param bandBandwidth the width of each band
+     * \param guardBandwidth the total width of the guard band
+     */
+    void SetRxSpectrumModel(const std::vector<MHz_u>& centerFrequencies,
+                            MHz_u channelWidth,
+                            Hz_u bandBandwidth,
+                            MHz_u guardBandwidth);
 
     /**
      * Set the vector of spectrum bands handled by this interface
@@ -159,8 +151,8 @@
     Ptr<SpectrumWifiPhy> m_spectrumWifiPhy;     ///< spectrum PHY
     Ptr<NetDevice> m_netDevice;                 ///< the device
     Ptr<SpectrumChannel> m_channel;             ///< spectrum channel
-    uint16_t m_centerFrequency;                 ///< center frequency in MHz
-    uint16_t m_channelWidth;                    ///< channel width in MHz
+    std::vector<MHz_u> m_centerFrequencies;     ///< center frequency per segment
+    MHz_u m_channelWidth;                       ///< channel width
     Ptr<const SpectrumModel> m_rxSpectrumModel; ///< receive spectrum model
 
     WifiSpectrumBands
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-signal-parameters.cc ns-3.43/src/wifi/model/wifi-spectrum-signal-parameters.cc
--- ns-3.42/src/wifi/model/wifi-spectrum-signal-parameters.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-signal-parameters.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Nicola Baldo <nbaldo@cttc.es>
  * Modified by Marco Miozzo <mmiozzo@cttc.es> (add data and ctrl diversity)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-signal-parameters.h ns-3.43/src/wifi/model/wifi-spectrum-signal-parameters.h
--- ns-3.42/src/wifi/model/wifi-spectrum-signal-parameters.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-signal-parameters.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 CTTC
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Nicola Baldo <nbaldo@cttc.es>
  * Modified by Marco Miozzo <mmiozzo@cttc.es> (add data and ctrl diversity)
@@ -21,6 +10,8 @@
 #ifndef WIFI_SPECTRUM_SIGNAL_PARAMETERS_H
 #define WIFI_SPECTRUM_SIGNAL_PARAMETERS_H
 
+#include "wifi-phy-common.h"
+
 #include "ns3/spectrum-signal-parameters.h"
 
 namespace ns3
